/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: ComponentTypeContext.java,v 1.2 2004/04/14 09:43:14 rouvoy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.context;

import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.core.naming.AbstractContext;
import org.objectweb.util.browser.core.naming.DefaultEntry;
import org.objectweb.util.browser.core.naming.DefaultName;

/**
 * Wrapper on component type. 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class ComponentTypeContext 
     extends AbstractContext 
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    
    /** The component type. */
    private ComponentType ct_ = null;
    
    // ==================================================================
    //
    // No Constructors.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods for interface Context.
    //
    // ==================================================================
    
    /**
     * Returns an array containing the entries contained by the target context.
     * @return A new array of entry.
     */
    public Entry[] getEntries() {
        java.util.List values = new java.util.ArrayList();
        InterfaceType[] objects = ct_.getFcInterfaceTypes();
        for (int i = 0; i < objects.length; i++)
            values.add(new DefaultEntry(objects[i], 
                       new DefaultName(NameProvider.singleton.getName(objects[i])), 
                       this));
        return (Entry[])values.toArray(new Entry[0]);         
    }
    
    // ==================================================================
    //
    // Additional public methods for Wrapper interface.
    //
    // ==================================================================
    
    /**
     * Fix the wrapped object.
     * @param object The object to wrap
     */
    public void setWrapped(Object object) {
        ct_ = (ComponentType) object;
    }
    
    /**
     * Gets the wrapped object.
     * @return The wrapped object.
     */
    public Object getWrapped() {
        return ct_;
    }
}
