/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.gui.lib;

import java.awt.Component;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.objectweb.util.browser.gui.api.DialogBox;
import org.objectweb.util.browser.core.common.DynamicTree;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class ExtendedTreeChooserBox 
    extends TreeChooserBox {

    //==================================================================
    //
    // Internal state.
    //
    //==================================================================

    /** The dialog to use*/
    protected DialogBox dialog_;
    
    /** The list of interface type */
    protected List treeChooserBoxes_;

    //==================================================================
    //
    // Constructors.
    // 
    //==================================================================

    /**
     * Default constructor
     * @param label The label of the box
     * @param tree The DynamicTree to use
     */     
    public ExtendedTreeChooserBox(String label, DynamicTree tree, DialogBox dialog) {
        super(label, tree, false);
        treeChooserBoxes_ = new Vector();
        treeChooserBoxes_.add(this);
        browseButton_.setAction(new ExtendedBrowseAction(this));
        dialog_ = dialog;
    }

    //==================================================================
    //
    // Internal methods.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================

    public Object[] getObjects(){
        List l = new Vector();
        Iterator it = treeChooserBoxes_.iterator();
        while (it.hasNext()) {
            TreeChooserBox element = (TreeChooserBox) it.next();
            Object o = element.getObject(); 
            if(o!=null)
                l.add(element.getObject());
        }
        return (Object[])l.toArray(new Object[0]);
    }

    //==================================================================
    //
    // Internal class.
    //
    //==================================================================
    
    protected class ExtendedBrowseAction extends BrowseAction{
        
        protected ExtendedBrowseAction(Component parent) {
            super(parent);      
        }
        
        public void actionPerformed(java.awt.event.ActionEvent ae) {
            super.actionPerformed(ae);
            // Create a new TreeChooser
            if(object_!=null){
                TreeChooserBox interfaceBox = new ExtendedTreeChooserBox("Interface Type",tree_, ExtendedTreeChooserBox.this.dialog_);
                ExtendedTreeChooserBox.this.treeChooserBoxes_.add(interfaceBox);
                ExtendedTreeChooserBox.this.dialog_.addElementBox(interfaceBox);
                ExtendedTreeChooserBox.this.dialog_.show();
            }
        }
    }

}