package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;
import java.util.Vector;
import intt.itu.itut_x780.ManagedObjectValueType;
import ist.coach.coachEmsMib.SnmpProtocolMonitorValueType;
import ist.coach.coachEmfClientComponents.InvokeSetData;

import ist.coach.coachEmfCommon.Utils;


public class VisualSnmpProtocolMonitor
extends MOTreeObject {

    static String[] subordinate_names = new String[0];

    static boolean canRefresh = false;
    static String object_type = "SnmpProtocolMonitor";
    static String emsClassName = "ist.coach.coachEmsMib.SnmpProtocolMonitor_F";

	static String DISPLAY_TYPE = "SNMP Protocol Monitor";

	    //
    // create arguments
    //
    static String[] create_arg_name =  new String[0];
    static String[] create_arg_editor =  new String[0];
    static String[] create_arg_renderer =  new String[0];

            //
            // settable arguments
            //
	static int ENABLE_AUTH_TRAP_POS = 31;


    static String[] attributes_name = {         //ManagedObject
                                        "Name",
                                        "Element Type",
                                        "Creation Source",
                                        "Delete Policy",
											//SnmpProtocolMonitor
										"Incoming SNMP Messages Received",
										"Outgoing SNMP Messages Sent",
										"Incoming SNMP Messages with Unsupported Version ",
										"Incoming SNMP Messages with Unknown Community",
										"Incoming SNMP Messages with Unsupported Operation on Community",
										"Incoming SNMP Messages with ASN.1 or BER Errors",
										"Incoming SNMP PDUs with Error Status Set to \"tooBig\"",
										"Incoming SNMP PDUs with Error Status Set to \"noSuchName\"",
										"Incoming SNMP PDUs with Error Status Set to \"badValue\"",
										"Incoming SNMP PDUs with Error Status Set to \"readOnly\"",
										"Incoming SNMP PDUs with Error Status Set to \"genErr\"",
										"Total Number of Successfully Retrieved MIB Objects",
										"Total Number of Successfully Altered MIB Objects",
										"Total Number of SNMP Get Requests Processed",
										"Total Number of SNMP Get Next Requests Processed",
										"Total Number of SNMP Set Requests Processed",
										"Total Number of SNMP Get Response PDUs Processed",
										"Total Number of SNMP Traps Accepted",
										"Outgoing SNMP PDUs with Error Status Set to \"tooBig\"",
										"Outgoing SNMP PDUs with Error Status Set to \"noSuchName\"",
										"Outgoing SNMP PDUs with Error Status Set to \"badValue\"",
										"Outgoing SNMP PDUs with Error Status Set to \"genErr\"",
										"Total Number of SNMP Get Requests Generated",
										"Total Number of SNMP Get Next Requests Generated",
										"Total Number of SNMP Set Requests Generated",
										"Total Number of SNMP Get Response PDUs Generated",
										"Total Number of SNMP Traps Generated",
										"Generation of Authentication Failure Traps"


					};

	 static boolean[] attributes_readonly =  {
				    false,
				    false,
				    false,
				    false,
					false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
					false,
				    false,
					false,
					true
    };

	public VisualSnmpProtocolMonitor(String key) {
		super(key);
		leafIcon = new ImageIcon(VisualSnmpProtocolMonitor.class.getResource(
                "images/protocol_icon.gif"));
		nodeIcon = new ImageIcon(VisualSnmpProtocolMonitor.class.getResource(
                "images/protocol_icon.gif"));
		 toolTipText = new String(DISPLAY_TYPE);
	}

	public Object[] translate_values(ManagedObjectValueType original_value_type) {

		Object[] values = new Object[attributes_name.length];
        for (int i = 0; i < values.length; i++)
            values[i] = "unspecified";

        if (original_value_type == null)
            return values;

        Object[] mo_values = super.translate_values(original_value_type);
        int i = 0;
        for (i = 0; i < mo_values.length; i++)
            values[i] = mo_values[i];

		SnmpProtocolMonitorValueType value_type;
        value_type = (SnmpProtocolMonitorValueType) original_value_type;

		values[i++] = String.valueOf(value_type.snmpInPkts);
		values[i++] = String.valueOf(value_type.snmpOutPkts);
		values[i++] = String.valueOf(value_type.snmpInBadVersions);
		values[i++] = String.valueOf(value_type.snmpInBadCommunityNames);
		values[i++] = String.valueOf(value_type.snmpInBadCommunityUses);
		values[i++] = String.valueOf(value_type.snmpInASNParseErrs);
		values[i++] = String.valueOf(value_type.snmpInTooBigs);
		values[i++] = String.valueOf(value_type.snmpInNoSuchNames);
		values[i++] = String.valueOf(value_type.snmpInBadValues);
		values[i++] = String.valueOf(value_type.snmpInReadOnlys);
		values[i++] = String.valueOf(value_type.snmpInGenErrs);
		values[i++] = String.valueOf(value_type.snmpInTotalReqVars);
		values[i++] = String.valueOf(value_type.snmpInTotalSetVars);
		values[i++] = String.valueOf(value_type.snmpInGetRequests);
		values[i++] = String.valueOf(value_type.snmpInGetNexts);
		values[i++] = String.valueOf(value_type.snmpInSetRequests);
		values[i++] = String.valueOf(value_type.snmpInGetResponses);
		values[i++] = String.valueOf(value_type.snmpInTraps);
		values[i++] = String.valueOf(value_type.snmpOutTooBigs);
		values[i++] = String.valueOf(value_type.snmpOutNoSuchNames);
		values[i++] = String.valueOf(value_type.snmpOutBadValues);
		values[i++] = String.valueOf(value_type.snmpOutGenErrs);
		values[i++] = String.valueOf(value_type.snmpOutGetRequests);
		values[i++] = String.valueOf(value_type.snmpOutGetNexts);
		values[i++] = String.valueOf(value_type.snmpOutSetRequests);
		values[i++] = String.valueOf(value_type.snmpOutGetResponses);
		values[i++] = String.valueOf(value_type.snmpOutTraps);

		switch(value_type.snmpEnableAuthenTraps) {
		case 2:
			values[i] = new String("Disabled");
			break;
		case 1:
			values[i] = new String("Enabled");
			break;
		default:
			values[i] = new String("Unknown");
			break;
		}
		return values;
    }

    java.util.Vector translate_updates(java.util.Hashtable values) {

	     Vector updates = new Vector();
		 org.omg.CosNaming.NameComponent[] objectName = Utils.string2name(key);

		 if (values.containsKey(attributes_name[ENABLE_AUTH_TRAP_POS])) {

            String attr_value = (String) values.get(attributes_name[ENABLE_AUTH_TRAP_POS]);

			int auth_allowed_value =
			    ist.coach.coachEmsMib.SnmpProtocolMonitor_F.enabled;

			if (attr_value.equalsIgnoreCase("disabled")) {
			    auth_allowed_value =ist.coach.coachEmsMib.SnmpProtocolMonitor_F.disabled;
			}

			Object[] arg_val = {objectName, new Integer(auth_allowed_value)};

			InvokeSetData data_set = new InvokeSetData(emsClassName,
                        "snmpEnableAuthenTrapsSet",
                            arg_val
            );

            updates.add(data_set);
        }


		return updates;
	}
}
