package ist.coach.coachEmfClientComponents.gui;


import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import javax.swing.DefaultCellEditor;

import javax.swing.JScrollPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import java.awt.*;
import java.awt.event.*;

public class CreateParamsFrame extends JFrame
implements ActionListener, Runnable {

	GuiMaster master;
	GuiClient gui;
	String parent_key;
	String object_type;
	ParamTableModel myModel;
	String [] param_name = null;

    public CreateParamsFrame( String object_class,
							String parent_key,
							GuiMaster master,
							GuiClient gui,
            				int x_pos, int y_pos) {

		super(GuiMessages.options_create);
		this.master = master;
		this.parent_key = parent_key;
		this.gui = gui;

		System.err.println("Create was called for " +
			object_class + " class with parent " +
			parent_key);
		try {
			// HACK: Introspection used
			//
			param_name  = (String [])Class.forName(object_class).getDeclaredField("create_arg_name").get(null);
			 object_type = (String)Class.forName(object_class).getDeclaredField("object_type").get(null);
			//GuiClient.println("Read params:");
			//for (int i = 0; i < param_name.length; i++)
		//		GuiClient.println("param[" + i + "] = " + param_name[i]);
		}
		catch(java.lang.IllegalArgumentException e1) {
			GuiClient.println("IllegalArgumentException");
		}
		catch(java.lang.IllegalAccessException e2) {
			GuiClient.println("IllegalAccessException");
		}
		catch(java.lang.ClassNotFoundException e3) {
			GuiClient.println("ClassNotFoundException" + e3.getMessage());
		}
		catch(java.lang.NoSuchFieldException e4) {
			GuiClient.println("NoSuchFieldException");
		}


        myModel = new ParamTableModel(param_name);
        //JTable table = new JTable(myModel);
        JAttributesTable table = new JAttributesTable(myModel);
        table.setPreferredScrollableViewportSize(new Dimension(300, 70));
		table.setCellSelectionEnabled(true);

        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);

        //Set up real input validation for the integer column.
        // setUpIntegerEditor(table);

		JButton ok_button = new JButton(GuiMessages.ok_str);
        ok_button.addActionListener(this);
        ok_button.setToolTipText(GuiMessages.create_tooltip_str);

        JButton cancel_button = new JButton(GuiMessages.cancel_str);
        cancel_button.addActionListener(this);
        cancel_button.setToolTipText(GuiMessages.cancel_tooltip_str);

        JPanel submitPanel = new JPanel(new FlowLayout());
        submitPanel.add(ok_button);
        submitPanel.add(cancel_button);

        //Add the scroll pane to this window.
        getContentPane().add(scrollPane, BorderLayout.CENTER);
        getContentPane().add(submitPanel, BorderLayout.SOUTH);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
		setLocation(x_pos, y_pos);
        pack();
        setVisible(true);
    }

	public void run() {}

	public void actionPerformed(ActionEvent e) {

		if (e.getActionCommand().equals(GuiMessages.ok_str)) {

			Object[] values = new Object[myModel.getRowCount()];
			for(int i = 0; i < values.length; i++) {
				values[i] = myModel.getValueAt(i,  1);

				//myModel.printDebugData();
			}

			String new_object_name = master.createByManager(object_type,
				param_name,  values, parent_key);

			if (new_object_name.length() > 0) {
				gui.create(new_object_name, object_type);

				JOptionPane.showMessageDialog(this,
					GuiMessages.reply_ok,
					GuiMessages.options_create,
					JOptionPane.WARNING_MESSAGE);
			}

		}
		 this.dispose();
    }


/***
    private void setUpIntegerEditor(JTable table) {
        //Set up the editor for the integer cells.
        final WholeNumberField integerField = new WholeNumberField(0, 5);
        integerField.setHorizontalAlignment(WholeNumberField.RIGHT);

        DefaultCellEditor integerEditor =
            new DefaultCellEditor(integerField) {
                //Override DefaultCellEditor's getCellEditorValue method
                //to return an Integer, not a String:
                public Object getCellEditorValue() {
                    return new Integer(integerField.getValue());
                }
            };
        table.setDefaultEditor(Integer.class, integerEditor);
    }
*****/

}
