@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Philippe Merle.
rem # Contributor(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                 Christophe Demarey, Jerome Offroy,
rem #                 Briclet Frdric
rem #
rem # ====================================================================
rem #
rem # Starting a demonstration.
rem #
rem # %1: demonstration name.
rem #
rem # ====================================================================
call c:\corba\openccm\openccm\orbacus-4.1\bin\envi_openccm

@setlocal

rem # =====================
rem # Compute Command Line.
rem # =====================

set /a nb_args=0
for %%i in (%*) do set /a nb_args=nb_args+1

set /a nb=0
set with_ots="false"
set with_trace="false"
set with_trader="false"
set with_tracing="false"
set services_args=
set services_list=

:initial
if "%1" == "-h" goto help
if "%1" == "--ots" goto ots
if "%1" == "--trace" goto trace
if "%1" == "--trader" goto trader
if "%1" == "--tracing" goto coach_tracing
if not "%1" == "" goto help
if %nb% == %nb_args% (goto end_command_line) else (goto arguments)

:ots
set with_ots="true"
set services_list=%services_list% Transactional
set services_args=%services_args% --ots
shift
set /a nb=nb+1
goto initial

:trace
set with_trace="true"
set services_list=%services_list% Trace
set services_args=%services_args% --trace
shift
set /a nb=nb+1
goto initial

:coach_tracing
set with_tracing="true"
set services_list=%services_list% Tracing
set services_args=%services_args% --tracing
shift
set /a nb=nb+1
goto initial

shift
set /a nb=nb+1
goto initial

:trader
set with_trader="true"
shift
set /a nb=nb+1
goto initial

:arguments
shift
set /a nb=nb+1
goto initial

:help
echo usage: start_ccm_envi [--ots] [--trace] [--trader]
goto :eof

:end_command_line

rem # =============================
rem # Install the OpenCCM Platform.
rem # =============================

call ccm_install

rem # =============================
rem # Start the Name Service.
rem # =============================

call comanche_start
call ns_start

rem # ==============================
rem # Start the Transaction Service.
rem # ==============================

if %with_ots% == "true" (call ots_start)

rem # ==============================
rem # Start the Trading Service.
rem # ==============================

if %with_trader% == "true" (call trader_start)

rem # ==============================
rem # Start the Coach Tracing Service.
rem # ==============================

if %with_tracing% == "true" (call coach_tracing_start)

rem # ===========================================
rem # Obtain the IOR of the started Name Service.
rem # ===========================================

call ns_ior > %OpenCCM_CONFIG_DIR%\%demo_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\%demo_name%.tmp) do set ior_NS=%%i
del %OpenCCM_CONFIG_DIR%\%demo_name%.tmp

rem # ==================================================
rem # Obtain the IOR of the started Transaction Service.
rem # ==================================================

if %with_ots% == "false" goto :jcs
call ots_ior > %OpenCCM_CONFIG_DIR%\%demo_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\%demo_name%.tmp) do set ior_OTS=%%i
del %OpenCCM_CONFIG_DIR%\%demo_name%.tmp

rem # =============================
rem # Start Java Component Servers.
rem # =============================

:jcs
rem # call jcs_start %services_args% ComponentServer1
rem # call jcs_start %services_args% ComponentServer2
rem # call jcs_start %services_args% ComponentServer3

rem # =============================
rem # Start DCI Manager.
rem # =============================
call dci_start DefaultDCI

rem # waits for the DCI IOR to be written
:dci_wait
if not exist %OpenCCM_CONFIG_DIR%\DCI.IOR goto :dci_wait

rem # =============================
rem # Start Java AssemblyFactory.
rem # =============================
call factory_start DefaultFactory

rem # =============================
rem # Start Java Node.
rem # =============================
rem # call node_start %services_args% FirstNode
rem # call node_start %services_args% SecondNode
rem # call node_start %services_args% ThirdNode
call node_start %services_args% MainNode
call node_start %services_args% MibNode
rem # call node_start %services_args% ClientNode


:end
echo The OpenCCM MainNode, ComponentServers and Services have started
