package ist.coach.coachEmfServices.EmfBasicLog;

import org.omg.CORBA.*;


public class IteratorImpl extends IteratorPOA
{

	private LogRecord[] logRecords_ = null;
	private int logRecordsSize_ = 0;


	public void logRecords(LogRecord[] records) {
		logRecords_ = records;
	}

	public LogRecord[] logRecords() {
		return logRecords_;
	}

	public void logRecordsSize(int recordsSize) {
		logRecordsSize_ = recordsSize;
	}

	public int logRecordsSize() {
		return logRecordsSize_;
	}

	/************************************************************************/
	/* METHOD 'get'	 									*/
	/************************************************************************/
    	public LogRecord[] get(int position, int how_many) throws InvalidParam
    	{
		if ( position > logRecordsSize_ ) {
			String detailsStr = "Position (" + position +
					") requested is greater than the number of records (" +
					logRecordsSize_ + ")";
			InvalidParam ex_InvalidParam = new InvalidParam(detailsStr);
			throw ex_InvalidParam;
		}

		if (  ( position + how_many ) > logRecordsSize_ ){
			how_many = logRecordsSize_ - position;
		}

		LogRecord[] recSnapshot = new LogRecord[how_many];

		for (int i = 0; i <= (how_many - 1); i++) {
			recSnapshot[i] = logRecords_[ position + i];
		}

		return recSnapshot;

    	} // End of Method 'get'

	/************************************************************************/
	/* METHOD 'destroy' 									*/
	/************************************************************************/
    	public void destroy()
	{

		System.out.println( "*** BasicLogImpl:  < DESTROY() > Not implemented Yet" );
	}

} // End of Class 'IteratorImpl'
