/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.AlarmChannelProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfServices.EmfBasicLog.*;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmfServicesComponents/AlarmChannelProviderComposition/AlarmChannelProviderHome_impl/AlarmChannelProvider_impl/objectCreationSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class objectCreationSegImpl
     extends ist.coach.coachEmfServicesComponents.AlarmChannelProviderComposition.objectCreationSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public objectCreationSegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816Components::CCM_ObjectCreationConsumer::push operation.
     */
    public void
    push(ist.coach.itut_q816Components.ObjectCreation event)
    {
        //
        // DONE : Implement
        //
		//System.err.println("Object creation event received for " + event.sourceClass);
		String[] excludedEventTypes = get_main_segment().excludedeventTypes();
		for (int i = 0; i < excludedEventTypes.length; i++) {
				if (excludedEventTypes[i].equals("ObjectCreation"))
					return;
		}
		String[] excludedEventSources = get_main_segment().excludedSourceClasses();
		for (int i = 0; i < excludedEventSources.length; i++) {
				if (excludedEventSources[i].equals(event.sourceClass))
					return;
		}
		String[] eventTypes = get_main_segment().eventTypes();
		boolean eventSupported = false;	
		for (int i = 0; i < eventTypes.length; i++) {
				if (eventTypes[i].equals("ObjectCreation")) {
					eventSupported = true;
					break;
				}
		}
		if (! eventSupported) return;

		String[] eventSources = get_main_segment().sourceClasses();
		boolean eventSourceSupported = false;
		for (int i = 0; i < eventSources.length; i++) {
				if (eventSources[i].equals(event.sourceClass)) {
					eventSourceSupported = true;
					break;
				}
		}
		if (!eventSourceSupported) return;

		get_context().push_objectCreation_alarm(event);
		BasicLog logSupport = get_context().get_connection_basic_log();
		Utils.pretty_log(logSupport, Utils.name2string(event.source),
			    event.sourceClass,
			(short) LogSeverity._Info,
		    "ObjectCreation " + event.notificationIdentifier);
    }

}
