/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.BasicLogProviderComposition;

import java.sql.*;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmfServicesComponents/BasicLogProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class BasicLogProviderImpl
     extends ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.BasicLogProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
	private int     recordsReadRange_;
	private int     logId_;
	private int     logMaxSize_;
	private String  databaseConnection_;
	private String  databaseTable_;
	private String  databaseDriver_;
	private short   logFullAction_;
	private String  databaseUserData_ = "?user=test1&password=test1";
	private String  display_name_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public BasicLogProviderImpl()
    {
    }

	public BasicLogProviderImpl(int logId)
    {
	  if (logId > 0)
		  logId_ = logId;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {

        //
        //  DONE : implement !!!
        //

		  org.omg.CORBA.ORB orb =
                org.objectweb.ccm.CORBA.TheORB.getORB();

		  if (logId() == 0)
			throw new org.omg.Components.InvalidConfiguration();

	      String logIDstr = Integer.toString(logId());
	      logIDstr = databaseTable() + logIDstr;

		    // Crete a new table named by 'logIDstr' in the given database. The
			// structure of the schema is based on the 'LogRecord'(defined in
			// Log.idl. In summary it contains:
			// - logRecordId : Unique number assigned to the record by the Log,
            	// - timeStamp : Timestamp indicating the time an event is logged,
            	// - attrList : User defined name/value pairs,
			// - logData : data details received by the log as an event.
		// Connect to JDBC driver
		try	{
			Class.forName(databaseDriver()).newInstance();
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl: <EXCEPTION> While connecting to jdbc driver");
			System.err.println(ex.getMessage());

		}

		Connection dbConnection = null;
		try {
			    dbConnection = DriverManager.getConnection(databaseConnection());
				Statement  dbStatement = dbConnection.createStatement();
				String sqlStr = 	"CREATE TABLE " + logIDstr +
							"(logRecordId BIGINT PRIMARY KEY, " +
							"timeStamp VARCHAR(30), " +
							"logDataType TINYINT, " +
							"logData BLOB)";

    			boolean  logCreatedInDb = dbStatement.execute(sqlStr);
		  }
		  catch (SQLException ex) {
			  System.err.println(logIDstr + " Table propably already exists in the database...");
			  //System.err.println("*** BasicLogFactoryImpl : SQLException: " + ex.getMessage());
			  //System.err.println("*** BasicLogFactoryImpl : SQLState: " + ex.getSQLState());
			  //System.err.println("*** BasicLogFactoryImpl : VendorError: " + ex.getErrorCode());
		  }
	  System.err.println("LogProvider " + display_name() + " configuration completed...");
	}

    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
	/************************
	    String logIDstr = Integer.toString(logId());
		logIDstr = databaseTable() + logIDstr;
		Connection dbConnection = null;
		try {
			    dbConnection = DriverManager.getConnection(databaseConnection());
				Statement  dbStatement = dbConnection.createStatement();
				String sqlStr = "DROP TABLE " + logIDstr;

    			boolean  logCreatedInDb = dbStatement.execute(sqlStr);
		  }
		  catch (SQLException ex) {
			  System.err.println(logIDstr + " Table can not be deleted by the database...");
			  System.err.println("*** BasicLogFactoryImpl : SQLException: " + ex.getMessage());
			  System.err.println("*** BasicLogFactoryImpl : SQLState: " + ex.getSQLState());
			  System.err.println("*** BasicLogFactoryImpl : VendorError: " + ex.getErrorCode());
		  }
	 ********************/
	}
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================
     /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::recordsReadRange attribute as accessor operation.
     */
    public int
    recordsReadRange()
    {
        //
        // DONE : Implement
        //
        return recordsReadRange_;
    }
    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::recordsReadRange attribute as mutator operation.
     */
    public void
    recordsReadRange(int val)
    {
        //
        // DONE : Implement
        //
		if (val > 0)
		    recordsReadRange_ = val;
		//System.err.println("BasicLogProviderImpl>recordsReadRange set to " + val);
    }

     /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::logFullAction attribute as accessor operation.
     */
    public short
    logFullAction()
    {
        //
        // DONE : Implement
        //
        return logFullAction_;
    }
    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::logFullAction attribute as mutator operation.
     */
    public void
    logFullAction(short val)
    {
        //
        // DONE : Implement
        //
		if (val > 0)
		    logFullAction_ = val;
		//System.err.println("BasicLogProviderImpl>logFullAction set to " + val);
    }
	/**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::logMaxSize attribute as accessor operation.
     */
    public int
    logMaxSize()
    {
        //
        // DONE : Implement
        //
        return logMaxSize_;
    }
    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::recordsReadRange attribute as mutator operation.
     */
    public void
    logMaxSize(int val)
    {
        //
        // DONE : Implement
        //
		if (val > 0)
		    logMaxSize_ = val;
		//System.err.println("BasicLogProviderImpl>logMaxSize set to " + val);
    }

	public void logId(int val) {
	    if (val > 0)
		  logId_ = val;

		//System.err.println("BasicLogProviderImpl>logId set to " + logId_);



	}

	public int logId() {
	  return logId_;
	}
    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::databaseConnection attribute as mutator operation.
     */
    public void
    databaseConnection(String val)
    {
        //
        // DONE : Implement
        //
		if (val != null && val.length() > 0)
		    databaseConnection_ = val + databaseUserData_;
		//System.err.println("BasicLogProviderImpl>databaseConnection set to " + databaseConnection_);
    }
     /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::databaseConnection attribute as accessor operation.
     */
    public String
    databaseConnection()
    {
        //
        // DONE : Implement
        //
        return databaseConnection_;
    }

   /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::databaseDriver attribute as mutator operation.
     */
    public void
    databaseDriver(String val)
    {
        //
        // DONE : Implement
        //
		if (val != null && val.length() > 0)
		    databaseDriver_ = val;
		//System.err.println("BasicLogProviderImpl>databaseDriver set to " + val);
    }
     /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::databaseDriver attribute as accessor operation.
     */
    public String
    databaseDriver()
    {
        //
        // DONE : Implement
        //
        return databaseDriver_;
    }

	  /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::databaseTable attribute as mutator operation.
     */
    public void
    databaseTable(String val)
    {
        //
        // DONE : Implement
        //
		if (val != null && val.length() > 0)
		    databaseTable_ = val;
		//System.err.println("BasicLogProviderImpl>databaseTable set to " + val);
    }
     /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::databaseTable attribute as accessor operation.
     */
    public String
    databaseTable()
    {
        //
        // DONE : Implement
        //
        return databaseTable_;
    }
    /**
     * Implementation of the ::coachEmfServicesComponents::CCM_BasicLogProvider_Executor::display_name attribute as accessor operation.
     */
	public void
    display_name(String val)
    {
        //
        // DONE : Implement
        //
		if (val != null && val.length() > 0)
		    display_name_ = val;

    }

	public String
    display_name()
    {
        //
        // DONE : Implement
        //
        return display_name_;
    }
}
