/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_q816Components.ContainmentServiceProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/itut_q816Components/ContainmentServiceProviderComposition/ContainmentServiceProviderHome_impl/ContainmentServiceProvider_impl/querySeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class querySegImpl
     extends ist.coach.itut_q816Components.ContainmentServiceProviderComposition.querySeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public querySegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816::Containment::exists operation.
     */
    public boolean
    exists(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

        if (ContainmentServiceProviderImpl.tree.containsKey(Utils.name2string(name)))
            return true;
        else
            return false;

    }

    /**
     * Implementation of the ::itut_q816::Containment::getContained operation.
     */
    public org.omg.CosNaming.NameComponent[][]
    getContained(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //
        org.omg.CosNaming.NameComponent[][] contained_objects =
		new org.omg.CosNaming.NameComponent[0][0];

		String name_str = Utils.name2string(name);

		if (ContainmentServiceProviderImpl.tree.containsKey(name_str)) {
            java.util.Vector contained_vector =
			    (java.util.Vector) ContainmentServiceProviderImpl.tree.get(name_str);

            contained_objects =
				new org.omg.CosNaming.NameComponent[contained_vector.size()][0];

            for(int i = 0; i < contained_vector.size(); i++) {

                String child_name = (String) contained_vector.elementAt(i);

                if (child_name == null || child_name.length() == 0)
                     System.err.println("Note that a NULL child found!");
                else {
				    contained_objects[i] = Utils.string2name(child_name);
                }
            }
		}
		//System.err.println("getContained returns " +
		//		contained_objects.length  + " children");
		return contained_objects;
    }

    /**
     * Implementation of the ::itut_q816::Containment::getContainedByKind operation.
     */
    public org.omg.CosNaming.NameComponent[][]
    getContainedByKind(org.omg.CosNaming.NameComponent[] name, String kind)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //
        		org.omg.CosNaming.NameComponent[][] contained_objects =
				new org.omg.CosNaming.NameComponent[0][0];
		String name_str = Utils.name2string(name);

		if (! ContainmentServiceProviderImpl.tree.containsKey(name_str)) {
			ApplicationErrorInfoTypeImpl error_code =
					new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = ExceptionMessages.root_delete_error;

        	throw new ApplicationError(error_code);
		}
        java.util.Vector contained_vector =
		  (java.util.Vector) ContainmentServiceProviderImpl.tree.get(name_str);

		java.util.Vector contained_by_kind_vector = new java.util.Vector();
		String child_str;
		for (int i = 0; i < contained_vector.size(); i++) {
			child_str = (String) contained_vector.elementAt(i);

			if (kind.equals(Utils.name2kind(child_str))) {
				contained_by_kind_vector.add(child_str);
			}

		}
		contained_objects = new org.omg.CosNaming.NameComponent[
					contained_by_kind_vector.size()][0];

		for(int j = 0; j < contained_by_kind_vector.size(); j++) {

			child_str = (String) contained_by_kind_vector.elementAt(j);

            if (child_str == null || child_str.length() == 0)
                System.err.println("NULL child found!");
            else
                contained_objects[j] = Utils.string2name(child_str);
		}

        return contained_objects;

    }

}
