/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents.IpNodeProviderComposition;

import intt.itu.itut_x780.UIDType;

import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;

import intt.itu.itut_m3120.NOuserLabelPackageException;
import intt.itu.itut_m3120.NOvendorNamePackageException;
import intt.itu.itut_m3120.NOversionPackageException;
import intt.itu.itut_m3120.NOlocationNamePackageException;

import ist.coach.coachEmfCommon.Utils;

import ist.coach.coachEmsCommon.IpNodeValueTypeImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ManagedObjectValueTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;

import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpNodeValueType;
import ist.coach.coachEmsMib.NOsysInformationSetPackageException;

import ist.coach.coachEmsCommon.SnmpIdentifiers;
import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;
import ist.coach.coachEmfServices.EmfBasicLog.*;
import java.util.Hashtable;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/IpNodeProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class IpNodeProviderImpl
     extends ist.coach.coachEmsMibComponents.IpNodeProviderComposition.IpNodeProvider_impl
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    org.omg.CORBA.ORB orb = null;

	private String _facade_name;
	private static int notifId = 10000;
	private BasicLog logSupport;

	protected static final int COLDSTART_TRAP = 1;
	protected static final int NETSNMP_SHUTDOWN_TRAP = 4;

	private static final String SYS_INFO_SET_PACKAGE = "sysInfoSetPackage";
	private static final String LOCATION_NAME_PACKAGE = "locationNamePackage";
	private static final String USER_LABEL_PACKAGE = "userLabelPackage";
	private static final String VENDOR_NAME_PACKAGE = "vendorNamePackage";
	private static final String VERSION_PACKAGE = "versionPackage";


	protected static Hashtable elements;

	ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;
	ist.coach.coachEmfServices.SnmpAdapter.SnmpTrapDaemon config = null;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpNodeProviderImpl()
    {
        elements = new Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================


    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================

    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

	  if ((connector = get_context().get_connection_connector()) == null)
			throw new org.omg.Components.InvalidConfiguration();

	  if ((config = get_context().get_connection_config()) == null)
			throw new org.omg.Components.InvalidConfiguration();

	  if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

	  orb = org.objectweb.ccm.CORBA.TheORB.getORB();
		System.err.println("IpNodeProvider configuration completed...");
    }

    /**
     **  Implementation of the ::coachEmsMibComponents::CCM_IpNodeProvider::get_snmp_callback operation.
     **/
    //public ist.coach.coachEmfServices.SnmpAdapter.CCM_TrapCallback
    //get_snmp_callback()
    //{
    //    return this;
   // }
    //
    //  IDL:coach.ist/itut_x780Components/CCM_NamedComponent_Executor/facade_name:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     **/
    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
		return _facade_name;
    }

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);


    }

    /**
     **  Implementation of the ManagedObject_F::nameGet operation.
     **/
    public NameComponent[] nameGet() {
        return Utils.string2name(_facade_name);
    }

    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/domainNameGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::domainNameGet operation.
     **/
    public java.lang.String
    domainNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.domainName;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/hostnameGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::hostnameGet operation.
     **/
    public java.lang.String
    hostnameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //


	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

	error_code.error = new UIDType(
		intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

	error_code.details = new String ("object with name" +
		key + " does not exist.");

	throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.hostname;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/managementIPAddressGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::managementIPAddressGet operation.
     **/
    public byte[]
    managementIPAddressGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

	error_code.error = new UIDType(
		intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

	error_code.details = new String ("object with name" +
		key + " does not exist.");

	throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.managementIPAddress;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/supportedSnmpVersionsGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::supportedSnmpVersionsGet operation.
     **/
    public int
    supportedSnmpVersionsGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //


	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

	error_code.error = new UIDType(
		intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

	error_code.details = new String ("object with name" +
		key + " does not exist.");

	throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.supportedSnmpVersions;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/snmpPortGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::snmpPortGet operation.
     **/
    public int
    snmpPortGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
		intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure data = (IpNodeDataStructure) this.elements.get(key);

	return data.snmpPort;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/ifNumberGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::ifNumberGet operation.
     **/
    public int
    ifNumberGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	DataType ifNumberData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		ifNumberData = this.connector.get(
			SnmpIdentifiers.IF_NUMBER_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve ifNumber " +
		 		"for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SnmpIdentifiers.IF_NUMBER_OID +
		 		" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the interface number: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = ifNumberData.value;

	if(value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve ifNumber " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.IF_NUMBER_OID +
			 " is not of type long, as expected.");

		throw new ApplicationError(error_code);

	}

	int ifNumber = value.extract_long();

	return ifNumber;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysDescrGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysDescrGet operation.
     **/
    public java.lang.String
    sysDescrGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE: implement
        //

	DataType sysDescrData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysDescrData = this.connector.get(
			SnmpIdentifiers.SYS_DESCR_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysDescr " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_DESCR_OID +
				 " does not exist.");
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the system description: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysDescrData.value;

	//if(value.type().kind().value() != TCKind._tk_string) {
	if(value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysDescr " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_DESCR_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}
	String sysDescr = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	//String sysDescr = value.extract_string();

	return sysDescr;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysObjectIDGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysObjectIDGet operation.
     **/
    public java.lang.String
    sysObjectIDGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	DataType sysObjectIDData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysObjectIDData = this.connector.get(
			SnmpIdentifiers.SYS_OBJECTID_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysObjectID " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_OBJECTID_OID +
				 " does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the system object id: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysObjectIDData.value;

	if(value.type().kind().value() != TCKind._tk_string) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysObjectID " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_OBJECTID_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}

	String sysObjectID = value.extract_string();

	return sysObjectID;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysUpTimeGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysUpTimeGet operation.
     **/
    public long
    sysUpTimeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
	DataType sysUpTimeData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysUpTimeData = this.connector.get(
			SnmpIdentifiers.SYS_UPTIME_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysUpTime " +
			 	"for IpNode Object with name " + key + ":" +
			 	" Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_UPTIME_OID +
			 	" does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the system up time: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysUpTimeData.value;

	if(value.type().kind().value() != TCKind._tk_longlong) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysUpTime " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_UPTIME_OID +
			 " is not of type long, as expected.");

		throw new ApplicationError(error_code);

	}

	long sysUpTime = value.extract_longlong();

	return sysUpTime;

    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysContactGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysContactGet operation.
     **/
    public java.lang.String
    sysContactGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //


	DataType sysDescrData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysDescrData = this.connector.get(
			SnmpIdentifiers.SYS_CONTACT_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
				error_code.details = new String ("Could not retrieve sysContact " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_CONTACT_OID +
				 " does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the contact details: " + e.reason);
		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysDescrData.value;

	//if(value.type().kind().value() != TCKind._tk_string) {
	if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysContact " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_CONTACT_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}
	String sysContact = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	//String sysContact = value.extract_string();

	return sysContact;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysContactSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysContactSet operation.
     **/
    public void
    sysContactSet(org.omg.CosNaming.NameComponent[] name, java.lang.String sysContact)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOsysInformationSetPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(SYS_INFO_SET_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + SYS_INFO_SET_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOsysInformationSetPackageException();
	}

	org.omg.CORBA.Any value = orb.create_any();
	//value.insert_string(sysContact);
	org.omg.CORBA.OctetSeqHelper.insert(value, sysContact.getBytes());
	DataTypeImpl sysContactData = new DataTypeImpl(
		SnmpIdentifiers.SYS_CONTACT_OID,
		value,
		SnmpSMI.SMI_STRING);

	try {

		this.connector.set(
			sysContactData,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.WRITE_COMMUNITY);
		}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not set sysContact " +
				 "for IpNode Object with name " + key + ".");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error setting the contact details: " + e.reason);
		throw new ApplicationError(error_code);

	}
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "sysContact set to " + sysContact);
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysNameGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysNameGet operation.
     **/
    public java.lang.String
    sysNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	DataType sysNameData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysNameData = this.connector.get(
			SnmpIdentifiers.SYS_NAME_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysName " +
			 	"for IpNode Object with name " + key + ":" +
			 	" Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_NAME_OID +
			 	" does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the system name: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysNameData.value;

	//if(value.type().kind().value() != TCKind._tk_string) {
	if(value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysName " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_NAME_OID +
			 " is not of type string, as expected.");

		throw new ApplicationError(error_code);

	}

	//String sysContact = value.extract_string();
	String sysName = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	return sysName;
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysNameSet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysNameSet operation.
     **/
    public void
    sysNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String sysName)
    throws intt.itu.itut_x780.ApplicationError, ist.coach.coachEmsMib.NOsysInformationSetPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(SYS_INFO_SET_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + SYS_INFO_SET_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOsysInformationSetPackageException();
	}

	org.omg.CORBA.Any value = orb.create_any();
	//value.insert_string(sysName);

	org.omg.CORBA.OctetSeqHelper.insert(value, sysName.getBytes());

	DataTypeImpl sysNameData = new DataTypeImpl(
		SnmpIdentifiers.SYS_NAME_OID,
		value,
		SnmpSMI.SMI_STRING);

	try {

		this.connector.set(
			sysNameData,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.WRITE_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not set sysName " +
				 "for IpNode Object with name " + key + ".");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error setting the system name: " + e.reason);

		throw new ApplicationError(error_code);

	}
		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "sysName set to " + sysName);
    }
    //
    //  IDL:coach.ist/coachEmsMib/IpNode_F/sysServicesGet:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNode_F::sysServicesGet operation.
     **/
    public short
    sysServicesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	DataType sysServicesData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}


	try {

		sysServicesData = this.connector.get(
			SnmpIdentifiers.SYS_SERVICES_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysServices " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_SERVICES_OID +
				 " does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the system services: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysServicesData.value;

	if(value.type().kind().value() != TCKind._tk_long) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysServices " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_SERVICES_OID +
			 " is not of type int, as expected.");

		throw new ApplicationError(error_code);

	}

	short sysServices = (short)value.extract_long();

	return sysServices;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/administrativeStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateGet operation.
     **/
    public intt.itu.itut_x780.AdministrativeStateType
    administrativeStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(
		Utils.name2string(name));

	return ipNodeData.administrativeState;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/administrativeStateSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::administrativeStateSet operation.
     **/
    public void
    administrativeStateSet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.AdministrativeStateType administrativeState)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	//HACK: Dummy operation! No support from underlying SNMP Agent!

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.administrativeState = administrativeState;
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "AdministrativeState set to " + administrativeState);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/operationalStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::operationalStateGet operation.
     **/
    public intt.itu.itut_x780.OperationalStateType
    operationalStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
    	//HACK: Dummy operation! No support from underlying SNMP Agent!

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(
		Utils.name2string(name));

	return ipNodeData.operationalState;

    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/usageStateGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::usageStateGet operation.
     **/
    public intt.itu.itut_x780.UsageStateType
    usageStateGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	//HACK: Dummy operation! No support from underlying SNMP Agent!

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}
	return intt.itu.itut_x780.UsageStateType.active;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/userLabelGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::userLabelGet operation.
     **/
    public java.lang.String
    userLabelGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOuserLabelPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(USER_LABEL_PACKAGE,
			packagesGet(name))) {
		throw new NOuserLabelPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.userLabel;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/userLabelSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::userLabelSet operation.
     **/
    public void
    userLabelSet(org.omg.CosNaming.NameComponent[] name, java.lang.String userLabel)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOuserLabelPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(USER_LABEL_PACKAGE,
			packagesGet(name))) {
		throw new NOuserLabelPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.userLabel = userLabel;
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "User Label set to " + userLabel);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/vendorNameGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::vendorNameGet operation.
     **/
    public java.lang.String
    vendorNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOvendorNamePackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VENDOR_NAME_PACKAGE,
			packagesGet(name))) {
		throw new NOvendorNamePackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.vendorName;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/vendorNameSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::vendorNameSet operation.
     **/
    public void
    vendorNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String vendorName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOvendorNamePackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VENDOR_NAME_PACKAGE,
				packagesGet(name))) {
		throw new NOvendorNamePackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.vendorName = vendorName;
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "Vendor Name set to " + vendorName);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/versionGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::versionGet operation.
     **/
    public java.lang.String
    versionGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VERSION_PACKAGE,
			packagesGet(name))) {
		throw new NOversionPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.version;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/versionSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::versionSet operation.
     **/
    public void
    versionSet(org.omg.CosNaming.NameComponent[] name, java.lang.String version)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOversionPackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(VERSION_PACKAGE,
			packagesGet(name))) {
		throw new NOversionPackageException();
	}

	IpNodeDataStructure ipNodeData = (IpNodeDataStructure)this.elements.get(key);

	ipNodeData.version = version;
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "Version set to " + version);
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/locationNameGet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::locationNameGet operation.
     **/
    public java.lang.String
    locationNameGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOlocationNamePackageException
    {
        //
        //  DONE : implement
        //

	DataType sysLocationData = null;

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(LOCATION_NAME_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + LOCATION_NAME_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOlocationNamePackageException();
	}


	try {

		sysLocationData = this.connector.get(
			SnmpIdentifiers.SYS_LOCATION_OID,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.READ_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
		new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not retrieve sysLocation " +
				 "for IpNode Object with name " + key + ":" +
				 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_LOCATION_OID +
				 " does not exist.");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the system location: " + e.reason);

		throw new ApplicationError(error_code);

	}

	org.omg.CORBA.Any value = sysLocationData.value;
	//by digi
	//if(value.type().kind().value() != TCKind._tk_string) {
	if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("Could not retrieve sysLocation " +
			 "for IpNode Object with name " + key + ":" +
			 " Object with Snmp Object Identifier " + SnmpIdentifiers.SYS_LOCATION_OID +
			 " is not of expected type.");

		throw new ApplicationError(error_code);

	}
	// by digi
	//String sysLocation = value.extract_string();
	String sysLocation = new String(org.omg.CORBA.OctetSeqHelper.extract(value));
	return sysLocation;
    }
    //
    //  IDL:itu.intt/itut_m3120/ManagedElement_F/locationNameSet:1.0
    //
    /**
     **  Implementation of the ::itut_m3120::ManagedElement_F::locationNameSet operation.
     **/
    public void
    locationNameSet(org.omg.CosNaming.NameComponent[] name, java.lang.String locationName)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_m3120.NOlocationNamePackageException
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	if (!Utils.packageIsSupported(LOCATION_NAME_PACKAGE,
			packagesGet(name))) {
		System.out.println("Package " + LOCATION_NAME_PACKAGE +
			"is not supported by IpNode Object" + key);

		throw new NOlocationNamePackageException();
	}

	org.omg.CORBA.Any value = orb.create_any();
	// by digi
	//value.insert_string(locationName);

	org.omg.CORBA.OctetSeqHelper.insert(value, locationName.getBytes());

	DataTypeImpl sysLocationData = new DataTypeImpl(
		SnmpIdentifiers.SYS_LOCATION_OID,
		value,
		SnmpSMI.SMI_STRING);

	try {

		this.connector.set(
			sysLocationData,
			new String(this.managementIPAddressGet(name)),
			this.snmpPortGet(name),
			SnmpIdentifiers.WRITE_COMMUNITY);
	}
	catch (SnmpApplicationError e) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		if (e.reason.equals(ExceptionMessages.agent_response_error))
			error_code.details = ExceptionMessages.agent_response_error;
		else
			error_code.details = new String ("Could not set sysLocation " +
				 "for IpNode Object with name " + key + ".");

		Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error setting the system location: " + e.reason);

		throw new ApplicationError(error_code);

	}
	Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "Location Name set to " + locationName);
  }

    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/

    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.objectclass;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	String userLabel = new String();
	String vendorName = new String();
	String version = new String();
	String locationName = new String();

	try {
		userLabel = userLabelGet(name);
	}
	catch (NOuserLabelPackageException noUserLabel) {

	}

	try {
		vendorName = vendorNameGet(name);
	}
	catch (NOvendorNamePackageException noVendorName) {

	}

	try {
		version = versionGet(name);
	}
	catch (NOversionPackageException noVersion) {

	}

	try {
		locationName = locationNameGet(name);
	}
	catch (NOlocationNamePackageException noLocation) {

	}

	IpNodeValueTypeImpl ipNodeValueType = new IpNodeValueTypeImpl(

		ipNodeData.administrativeState,
		this.operationalStateGet(name),
		this.usageStateGet(name),
		userLabel,
		vendorName,
		version,
		locationName,
		ipNodeData.domainName,
		ipNodeData.hostname,
		ipNodeData.managementIPAddress,
		ipNodeData.supportedSnmpVersions,
		ipNodeData.snmpPort,
		this.ifNumberGet(name),
		this.sysDescrGet(name),
		this.sysObjectIDGet(name),
		this.sysUpTimeGet(name),
		this.sysContactGet(name),
		this.sysNameGet(name),
		this.sysServicesGet(name),
		ipNodeData.name,
		ipNodeData.objectclass,
		ipNodeData.packageNameList,
		ipNodeData.sourceIndicator,
		ipNodeData.deletePolicy
	);
	  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name), (short) LogSeverity._Info,
		  "attributesGet finished OK");

	return ipNodeValueType;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.packageNameList;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.sourceIndicator;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

	String key = Utils.name2string(name);

	if (this.elements.containsKey(key) == false) {

		ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

		error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

		error_code.details = new String ("object with name" +
			key + " does not exist.");

		throw new ApplicationError(error_code);
	}

	IpNodeDataStructure ipNodeData =
		(IpNodeDataStructure)this.elements.get(key);

	return ipNodeData.deletePolicy;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (this.elements.containsKey(key) == false) {

			ApplicationErrorInfoTypeImpl error_code =
			new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
			intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
			intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("object with name" +
			key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpNodeDataStructure ipNodeData;
		synchronized(IpNodeProviderImpl.elements) {
		    ipNodeData = (IpNodeDataStructure) this.elements.remove(key);
		}
		try {
			config.unregister(name);
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_e) {
			System.err.println("There was a problem unregistering " + Utils.name2string(name) +
			" from the SNMP Trap Deamon");

			Utils.pretty_log(logSupport, Utils.name2string(name), 
			ipNodeData.objectclass, // objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error unregistering from the SNMP Trap Deamon: " + snmp_e.reason);
		}

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
										ipNodeData.objectclass,
										getUniqueNotificationIdentifier(),
										//ipNodeData.getUniqueNotificationIdentifier(),
										ipNodeData.sourceIndicator,
										new AttributeValueType[0]));
		Utils.pretty_log(logSupport,  Utils.name2string(name), 
			ipNodeData.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");
    }


  protected static int getUniqueNotificationIdentifier() {

            notifId++;

            return (notifId);
        }



}
