/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents.IpProtocolMonitorFactoryProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.CreateController;
import ist.coach.coachEmfCommon.CreateBindingInfo;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import ist.coach.coachEmsCommon.SnmpUtils;
import org.opennms.protocols.snmp.SnmpSMI;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;
import ist.coach.coachEmsCommon.SnmpIdentifiers;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import ist.coach.coachEmsMib.IpRoutingEntryFactory;
import ist.coach.coachEmsMib.IpToMACAddressFactory;

import intt.itu.itut_m3120.conditionalPackages.*;
import ist.coach.coachEmfServices.EmfBasicLog.*;

import org.omg.CosNaming.NameComponent;
import ist.coach.coachEmsMibComponents.IpProtocolMonitorMgmt;
/**
 **  Implementation skeleton class for the ::coachEmsMibComponents::IpProtocolMonitorFactoryProvider component.
 **/
public class IpProtocolMonitorFactoryProviderImpl
     extends ist.coach.coachEmsMibComponents.IpProtocolMonitorFactoryProviderComposition.IpProtocolMonitorFactoryProvider_impl
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/

	    /* Business logic **/
    intt.itu.itut_q816.ContainmentComponent c_admin = null;
    intt.itu.itut_q816.Containment c_query = null;

    private static final String FACTORY_CLASS = "LogicalInterfaceFactory";
    IpProtocolMonitorMgmt facade = null;
	private BasicLog logSupport;
    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;


    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpProtocolMonitorFactoryProviderImpl()
    {}
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================

    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

        if ((facade = get_context().get_connection_facade()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_admin = get_context().get_connection_containment_admin()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_query = get_context().get_connection_containment_query()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((connector = get_context().get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();

		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		System.err.println("IpProtocolMonitorFactoryProviderconfiguration completed...");


    }

    // ==================================================================
    //
    // Public methods for the CCM_IpProtocolMonitorFactoryProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMib/IpProtocolMonitorFactory/create:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpProtocolMonitorFactory::create operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    create(java.lang.String nameBindingID,
			org.omg.CosNaming.NameComponent[] superior,
			String reqID,
			String [] packageNameList,
			byte[] mgmtIpAddress,
			int snmpPort,
            int supportedSnmpVersions
	)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //   DONE : implement
        //

		String nameBinding_str = "ist.coach.coachEmsMib.NameBindings." +
            nameBindingID;

        CreateBindingInfo info = CreateController.checkNameBinding(nameBinding_str);

        String objectKind = info.objectKind;
        short deletePolicy = info.deletePolicy;

        // Check if the parent exists
        if (! c_query.exists(superior)) {
				ApplicationErrorInfoTypeImpl error_code =
						new ApplicationErrorInfoTypeImpl();
				error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);


				error_code.details = Utils.name2string(superior) +
                ExceptionMessages.parent_object_error;

            throw new ApplicationError(error_code);
        }

        // The system must have the capability to auto-name objects

        String allocatedId = null;
		if (reqID == null || reqID.length() == 0) {

        	org.omg.CosNaming.NameComponent[][] siblings =
        	c_query.getContained(superior);
			allocatedId = CreateController.autoCreateId(siblings);
		}
		else
			allocatedId = reqID;

        // Construct the name of the new object

        org.omg.CosNaming.NameComponent[] name = CreateController.createFullName(
                superior,
                allocatedId,
                Utils.name2facade(facade.facade_name()),
                objectKind);

        // Decide the conditional packages that are supported.
        String [] supportedConditionalPackages = packageNameList;

		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "proceed to create " + Utils.name2string(name));

       // if (packageNameList.length == 0)
         //   System.err.println("No packages are specified. ");
/****
        System.err.println("IpProtocolMonitorFactory> Before invoking the facade " +
				Utils.name2facade(facade.facade_name()) + " to create " +
          	Utils.name2string(name) + " port = " + snmpPort);
*******/
            facade.create(
					name,
                objectKind,
                packageNameList,
                deletePolicy,
                intt.itu.itut_x780.SourceIndicatorType.resourceOperation,
                superior,
				mgmtIpAddress,
                supportedSnmpVersions,
				snmpPort);

	        c_admin.addName(name, superior);
			//System.err.println("IpProtocolMonitorFactory>create returns for " +
              //  Utils.name2string(name));

				  // IpRoute Objects must also get created !

		DataType[] routeTable = new DataType[0];
		try {
			routeTable = this.connector.getSnmpTable(
				    SnmpIdentifiers.IP_ROUTE_TABLE_OID,
					new String(mgmtIpAddress),
            		snmpPort,
				    SnmpIdentifiers.READ_COMMUNITY); // "public"
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
			System.err.println("IpProtocolMonitorFactory: create>SnmpApplicationError caught: " +
						snmp_ex.reason);
				return name;
		}
		catch(Exception e) {
		  System.err.println("IpProtocolMonitorFactory: create>Exception caught: " + e.getMessage());
		  e.printStackTrace(System.err);
		}
/*****************************
		for(int i = 0; i < routeTable.length; i++) {
			try {
			    System.err.println("routeTable[" + i + "] = " +
				    routeTable[i].value.extract_string());
			}
			catch(Exception e1) {
			  try {
			    System.err.println("routeTable[" + i + "] = " +
				    routeTable[i].value.extract_long());
			  }
			  catch(Exception e2) {
				System.err.println("routeTable[" + i + "] can not be read");
			}
		  }
		}
****************************/
		int[] ipRouteDestIndexRows = { 1 };
			// Experimenting with Linux box proved 8 attributes are supported for ipRoutingEntry
		int numOfRouteColumns = 8;
		String [] ipRouteDest = SnmpUtils.getStringColumnData(routeTable,
			numOfRouteColumns, ipRouteDestIndexRows);

		if (ipRouteDest.length > 0) {
			  IpRoutingEntryFactory ip_address_factory =
				    get_context().get_connection_ipRoutingEntryFactory();

				if (ip_address_factory != null) {
					for(int i = 0; i < ipRouteDest.length; i ++) {
						ip_address_factory.create("IpRoutingEntry_IpProtocolMonitor",
											  name,
											  new String(),
											  new String[0],
											  ipRouteDest[i].getBytes(),
											  mgmtIpAddress,
											  snmpPort,
											  supportedSnmpVersions
										  );

					}
				}
		}

		    //IpToMACAddress objects must be created!

		//System.err.println("IpProtocolMonitorFactory> Proceeding to create IpToMACAddressObjects...");
		DataType[] ipToMACTable = new DataType[0];
		try {
			ipToMACTable = this.connector.getSnmpTable(
				    SnmpIdentifiers.IP_MACADDRESS_OID,
					new String(mgmtIpAddress),
            		snmpPort,
				    SnmpIdentifiers.READ_COMMUNITY); // "public"
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
			System.err.println("IpProtocolMonitorFactory: create>SnmpApplicationError caught: " +
						snmp_ex.reason);
				return name;
		}
		catch(Exception e) {
		  System.err.println("IpProtocolMonitorFactory: create>Exception caught: " + e.getMessage());
		  e.printStackTrace(System.err);
		}

		int[] iptoMACAddressIndexRows = { 1 };
			// Experimenting with Linux box proved 4 attributes are supported for ipToMACAddress
		int numOfMacColumns = 4;
		int[] iptoMACAddressIndexes = SnmpUtils.getIntColumnData(ipToMACTable,
			numOfMacColumns, iptoMACAddressIndexRows);

		int[]  ipNetToMediaNetAddressRows = { 3 };
		String[] ipNetToMediaNetAddress= SnmpUtils.getStringColumnData(ipToMACTable,
		    numOfMacColumns, ipNetToMediaNetAddressRows);

		if (iptoMACAddressIndexes.length > 0 &&
			    ipNetToMediaNetAddressRows.length == ipNetToMediaNetAddress.length ) {

				//System.err.println("iptoMACAddresses indexes found....");
			  IpToMACAddressFactory ip_mac_address_factory =
				    get_context().get_connection_ipToMACAddressFactory();

				if (ip_mac_address_factory != null) {
					for(int i = 0; i < iptoMACAddressIndexes.length; i ++) {
						//System.err.println("Ready to create IpTOMACAddress " +
						//					iptoMACAddressIndexes[i] + ", " + ipNetToMediaNetAddress[i]);
						ip_mac_address_factory.create("IpToMACAddress_IpProtocolMonitor",
											  name,
											  new String("IpToMACAddress" + (i+1)),
											  new String[0],
											  iptoMACAddressIndexes[i],
											  ipNetToMediaNetAddress[i].getBytes(),
											  mgmtIpAddress,
											  snmpPort,
											  supportedSnmpVersions
										  );

					}
				}
		}

/**********
		for(int i = 0; i < ipToMACTable.length; i++) {
			try {
			    System.err.println("ipToMACTable[" + i + "] = " +
				    ipToMACTable[i].value.extract_string());
			}
			catch(Exception e1) {
			  try {
			    System.err.println("ipToMACTable[" + i + "] = " +
				    ipToMACTable[i].value.extract_long());
			  }
			  catch(Exception e2) {
				try {
				  System.err.println("ipToMACTable[" + i + "] = " +
					  new String(org.omg.CORBA.OctetSeqHelper.extract(ipToMACTable[i].value)) +
						  " (byte string)");
				}
				catch(Exception e3) {
				  System.err.println("ipToMACTable[" + i + "] can not be read");
				}
			}
		  }
		}
*************/
					// ready to return

		Utils.pretty_log(logSupport, FACTORY_CLASS, "Factory", (short) LogSeverity._Info,
		  "successfully created " + Utils.name2string(name));
		return name;

    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObjectFactory/create_base:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObjectFactory::create_base operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    create_base(java.lang.String nameBinding,
					org.omg.CosNaming.NameComponent[] superior,
					java.lang.String reqId)
    throws intt.itu.itut_x780.CreateError, intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
        return  new NameComponent[0];
    }
}
