/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.ccm.chat.browser;

import javax.swing.JOptionPane;

import org.objectweb.ccm.chat.Server;
import org.objectweb.ccm.chat.ServerHome;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.TreeView;
import org.omg.Components.CCMObject;

/**
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class ServerCreationAction implements MenuItem {

    public int getStatus(TreeView treeView){
        ServerHome server = (ServerHome) treeView.getSelectedObject();
        CCMObject[] objects = server.get_components();
        if(objects.length==0)
            return MenuItem.ENABLED_STATUS;
        else
            return MenuItem.DISABLED_STATUS;
    }

    public void actionPerformed(MenuItemTreeView e) throws Exception {
        String name = "";
        while (name != null && name.equals("")) {
            name = JOptionPane.showInputDialog("Enter the server name :");
        }
        if (name != null) {
            ServerHome server = (ServerHome) e.getSelectedObject();
            Server s = server.create();
            s.name(name);
        }
    }

}
