/*===========================================================================

ObjectWeb Browser Framework
Copyright (C) 2003 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy, Areski Flissi.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.ccm.filetransfer.browser;

import java.awt.Component;
import javax.swing.JOptionPane;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;

import org.objectweb.ccm.filetransfer.Prog;
import org.objectweb.ccm.filetransfer.ProgHome;
import org.objectweb.openccm.browser.menu.OpenCCMBrowserConstants;
import org.objectweb.openccm.browser.menu.JFileChooserSingleton;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.gui.api.DialogAction;
import org.objectweb.util.browser.gui.api.DialogBox;
import org.objectweb.util.browser.gui.lib.DefaultDialogBox;
import org.objectweb.util.browser.gui.lib.LabelBox;
import org.objectweb.util.browser.gui.lib.FileChooserBox;

/**
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>,
 *         <a href="mailto:Areski.Flissi@lifl.fr">Areski Flissi</a>
 * @version 0.1
 */
public class ProgCreationAction 
    implements MenuItem, DialogAction {

    //==================================================================
    //
    // Internal states.
    //
    //==================================================================
    
    protected FileChooserBox channelDir_;
    
    protected ProgHome progHome_;
    
    //==================================================================
    //
    // No constructor.
    //
    //==================================================================

    //==================================================================
    //
    //No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for MenuItem interface.
    //
    //==================================================================

    public int getStatus(TreeView arg0){
        return MenuItem.ENABLED_STATUS;
    }

    public void actionPerformed(MenuItemTreeView e) throws Exception {
        progHome_ = (ProgHome) e.getSelectedObject();
        DialogBox dialogBox = new DefaultDialogBox("Choose a Program directory");      
        channelDir_ = new FileChooserBox("Dir",JFileChooserSingleton.getInstance(OpenCCMBrowserConstants.DIRECTORY_FILE_CHOOSER));
        dialogBox.addElementBox(channelDir_);
        dialogBox.setValidateAction(this);
        dialogBox.setValidateLabel("Create");
        dialogBox.setCancelLabel("Cancel");
        dialogBox.show();
    }

    //==================================================================
    //
    // Public methods for DialogAction interface.
    //
    //==================================================================

    /**
     * Executes an action
     */
    public void executeAction() throws Exception {
        File f = channelDir_.getFile();
        if (f != null && f.exists()) {
	        String name = f.getName();      
            Prog p = progHome_.create();
            p.the_name(name);
        }
    }

}