/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.registrar;

// Local Interface Import Statements
import org.objectweb.ccm.descriptor.componentassembly.beans.RegisterwithhomefinderBeanImpl;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
/**
 * This handler is used to produce registerwithomefinderdeployer from an
 * registerwithhomefinder bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class RegisterwithhomefinderDeployerHandler 
       extends HandlerBase 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ================================================================== 
    private RegisterwithhomefinderDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Produce the registerwithhomefinder deployer binded
     * to the givean @param reg.
     * 
     * @param reg The registerwithhomefinder bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */      
    public Object 
    getInstance(RegisterwithhomefinderBeanImpl reg)
    throws InitializationError 
    {
        if (_deploy == null) {
            _deploy = new RegisterwithhomefinderDeployer();
            _deploy.connectRegisterwithhomefinder(reg);
            applyCommonConfig(_deploy);
            _deploy.initialize();
        }
        return (_deploy);
    }

}
