/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;


/**
 * This is the implementation of the OMG IDL3 demo3::Consumer component type.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class AssemblyManagerModelHomeImpl
        extends org.objectweb.openccm.OpenCCM_DCI.AssemblyManagerModelSessionComposition.
                AssemblyManagerModelHomeImpl
//  implements CCM_NodeManagerHome
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    /*Path refering to the xml file used to create the lasted assembly*/
    private String xml_descriptor;

    private byte[] componentArchive;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /** The default constructor. */
    public
    AssemblyManagerModelHomeImpl()
    {
      super();
    }
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Methods for creation of component segments.
    //
    // ==================================================================

    /**
     * Create an executor segment from its identifier.
     *
     * @param segid The executor segment identifier.
     */
    public org.omg.Components.ExecutorSegmentBase
    create_executor_segment(int segid)
    {
        switch(segid)
            {
            case 0 :
                if(xml_descriptor!=null){
                    String tmp=xml_descriptor;
                    xml_descriptor=null;
                    return new AssemblyManagerModelImpl(tmp); 
                }
                else {
                    byte []tmp=componentArchive;
                    componentArchive=null;
                    return new AssemblyManagerModelImpl(tmp);
                }
                              
                
            case org.objectweb.openccm.OpenCCM_DCI.
                AssemblyManagerModelSessionComposition.
                AssemblyInstanceManagementSeg._segment_id_value
                : return new AssemblyInstanceManagementSegImpl();
                
            default:System.err.println("AssemblyManagerModel segmentation problem at creation!");
                    return null;
            }
    
    }

    // ==================================================================
    //
    // Methods for the deployment.
    //
    // ==================================================================

    /**
     * This method is called by the OpenCCM Component Server
     * to create a home instance.
     */
    public static org.omg.Components.HomeExecutorBase
    create_home()
    {
        
        return new AssemblyManagerModelHomeImpl();
    }
    
    /**
     * DCI ::create_assembly_model(xml_descriptor) factory method
     * @return The create component
     */
    public  org.omg.Components.EnterpriseComponent
    create_assembly_model(String xml_descriptor)
    {        
        this.xml_descriptor=xml_descriptor;
        return  create();
    }
    
    public  org.omg.Components.EnterpriseComponent
    create_assembly_model_archive(byte[] componentArchive)
    {        
        this.componentArchive=componentArchive;
        return  create();
    }

    /**
     * static block to register the AssemblyManagerRemoved event
     * which is used to manage the assembly manager removall.     
     */
    static
    {
        // Required to register the Food valuetype factory to the ORB.
        AssemblyManagerRemovedDefaultFactory.register();
    }

}
