/*===========================================================================
ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.browser.DCI;

/** The administration console's API imports */
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;

/** javax swing imports*/
import javax.swing.*;
import java.awt.Component;

/**
 * This action install an assembly with the specified descriptor
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class DCIInstallDescriptor 
    implements MenuItem {

    public int getStatus(TreeView treeView){
        return MenuItem.ENABLED_STATUS;    
    }

    public void actionPerformed(MenuItemTreeView e) throws Exception {
        org.ist.coach.DCI.DCIDeployment dciDeployment=
            (org.ist.coach.DCI.DCIDeployment)e.getSelectedObject();

        javax.swing.JPanel pan = new javax.swing.JPanel();
        javax.swing.JTextArea description =new javax.swing.JTextArea(30,30);

        javax.swing.JScrollPane areaScrollPane = new javax.swing.JScrollPane(description);
        areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        areaScrollPane.setPreferredSize(new java.awt.Dimension(300,300));
        pan.add(areaScrollPane);
        int result = 
            javax.swing
            .JOptionPane
            .showOptionDialog(
                              (Component)e.getActionEvent().getSource(),
                              pan,
                              "Install a descriptor",
                              JOptionPane.OK_CANCEL_OPTION,
                              JOptionPane.PLAIN_MESSAGE,
                              null,
                              null,
                              null);
        //if(result==1)
        dciDeployment.install_with_descriptor(description.getText());
        
    }

}
