/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.api;

/** To use the Entry interface */
import org.objectweb.util.browser.naming.api.Entry;

/**
 * Toolkit implementation for GUI Properties manipulation.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */

public interface PropertyTools {

    /**
     * Finds the object associated value. 
     * If the key doesn't exist, it looks for in interfaces implemented 
     * by this class and in superclass of the entity.
     * In order to have a string representation of the object, 
     * it takes his name (object.getClass().getName())
     * @param object The research key
     * @return The associated value - null is returned if no value exists
     */
    public Entry getRecursiveProperty(Object object);

}
