/*===========================================================================

ObjectWeb Naming Context Framework
Copyright (C) 2002 USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jrme Moroy.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.util.browser.gui.panel;

/** To use the Field class */
import java.lang.reflect.Field;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.BoxLayout;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Color;
import javax.swing.Box;

/**
 * This class represents a Field
 *
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 *
 */
public class FieldGUI extends Box {

    protected Object object_;

    protected Field field_;

    public FieldGUI(Field field, Object object) {
        super(BoxLayout.X_AXIS);
        field_ = field;
        object_ = object;

        setBackground(Color.white);

        add(Box.createHorizontalGlue());

        Class type = field_.getType();
        int lastIndex = type.getName().lastIndexOf('.');
        JLabel label = null;
        if (lastIndex != -1)
            label = new JLabel(field.getName() + " : " + type.getName().substring(lastIndex + 1));
        else
            label = new JLabel(field.getName() + " : " + type.getName());

        label.setPreferredSize(new Dimension(350, 20));
        add(label);

        add(Box.createHorizontalStrut(10));

        JButton value = new JButton("Value");
        value.setPreferredSize(new Dimension(80, 20));
        value.addActionListener(new ValueAction());
        add(value);

        add(Box.createHorizontalGlue());
    }

    protected class ValueAction implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            try {
                System.out.println(field_.get(object_).toString());
            } catch (java.lang.IllegalAccessException ex) {
                ex.printStackTrace();
            } catch (java.lang.IllegalArgumentException ex) {
                ex.printStackTrace();
            }
        }
    }

}







