@echo off
rem # ====================================================================
rem #
rem # COACH: Component Based Open Source Architecture for
rem #        Distributed Telecom Applications
rem # See:   http://www.ist-coach.org/
rem #
rem # Copyright (C) 2003 Lucent Technologies Nederland BV
rem #                    Bell Labs Advanced Technologies - EMEA
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Harold Batteram
rem # Contributor(s): Philippe Merle.
rem #
rem # ====================================================================
rem #
rem # Starting an Actor Console.
rem #
rem # ====================================================================

rem # the argument
set args=""

rem # =============================
rem # Install the OpenCCM Platform.
rem # =============================

call ccm_install

rem # =======================
rem # Start the Name Service.
rem # =======================

call ns_start

rem # ==================
rem # Start TraceServer.
rem # ==================

call coach_tracing_start

rem # =======================================
rem # Start the OpenCCM Interface Repository.
rem # =======================================

call ir3_start_with_all

for /f %%i in (%OpenCCM_CONFIG_DIR%\NameService.IOR) do set IOR_NS=%%i
set args=-ORBInitRef NameService=%IOR_NS%

for /f %%i in (%OpenCCM_CONFIG_DIR%\IR3.IOR) do set IOR_IR=%%i
set args=%args% -ORBInitRef InterfaceRepository=%IOR_IR%

echo The COACH Actor will be started.

rem # ========================
rem # Start the Actor Console.
rem # ========================

echo Launching the COACH Actor.
call launcher fork "" "%* %args% %OpenCCM_HOMEDIR%\xml\launcher\Actor.xml" %OpenCCM_CONFIG_DIR%\Actor.output %OpenCCM_CONFIG_DIR%\Actor.PID
