@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2004 USTL - LIFL - GOAL
rem # Contact: openccm-team@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Areski Flissi
rem # Contributor(s): 
rem #
rem # ====================================================================
rem #
rem #  Start the OpenCCM Node Manager (PDA/WinCE distribution)
rem #
rem #  Usage: node_start [NS_IOR] [DCI_IOR] [NodeName]
rem #
rem # ====================================================================


if "%1" == "" goto set_default_ns_host
set ns_host=%1
goto set_dci_name

:set_default_ns_host
set ns_host=@NS_IOR@

:set_dci_name
if "%2" == "" goto set_default_dci_name
set dci_name=%2
goto set_node_name

:set_default_dci_name
set dci_name=@DCI_IOR@

:set_node_name
if "%3" == "" goto set_default_node_name
set node_name=%3
goto start_node

:set_default_node_name
set node_name=@NODE_NAME@


:start_node
echo Starting OpenCCM DCI Node

set OpenCCM_CONFIG_DIR=@OpenCCM_DIR@\OpenCCM_CONFIG_DIR\
set NODE_PATH=%OpenCCM_CONFIG_DIR%\NodeManagers\%node_name%\node_%node_name%

mkdir %OpenCCM_CONFIG_DIR%\NodeManagers\%node_name%\
set ci_dir=%OpenCCM_CONFIG_DIR%\NodeManagers\%node_name%\ComponentInstallation
mkdir %ci_dir%

set work_dir=%OpenCCM_CONFIG_DIR%\NodeManagers\%node_name%

echo "No User Node Properties File define, use default properties"

set run_id=node_start_default

:run

set npdFilePath=-I@OpenCCM_DIR@\xml/descriptor/dci/NodeProperties.npd

@JVM@ -Dior_ns=%ns_host% -Dior_dci=%dci_name% -Dnode_name=%node_name% -Dci_dir=%ci_dir% -Dwork_dir=%work_dir% org.objectweb.util.launcher.Launcher --runid %run_id% NPDFILE=%npdFilePath% NSREGISTER=OpenCCM/NodeManagers/%node_name% NODENAME=%node_name% @OpenCCM_DIR@\xml\launcher\node_server.xml

echo " The NodeManager %node_name% is started"

