/*====================================================================

ObjectWeb Util Launcher Package.
Copyright (C) 2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): .

--------------------------------------------------------------------
$Id: LauncherCmdline.java,v 1.1 2004/02/05 20:29:57 rouvoy Exp $
====================================================================*/

package org.objectweb.util.launcher;


import org.objectweb.util.cmdline.lib.DefaultCommandLine;

import org.objectweb.util.launcher.option.OptionArg;
import org.objectweb.util.launcher.option.OptionContext;
import org.objectweb.util.launcher.option.OptionDebug;
import org.objectweb.util.launcher.option.OptionLoad;
import org.objectweb.util.launcher.option.OptionProperty;
import org.objectweb.util.launcher.option.OptionRun;
import org.objectweb.util.launcher.option.OptionVerbose;


/**
 * LauncherCmdline specialization of DefaultCommandLine object.
 * <p>
 * this structure considers only characters list.
 * </p>
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public class LauncherCmdline
     extends DefaultCommandLine
{
    /**
     * Default Constructor
     */
    public LauncherCmdline() {
        super(new String[] {"java org.objectweb.util.launcher.Launcher"},
              new String[] {"file:<my_application.xml>"},
              true,
              new String[] {"Launch a new application", 
                            "The application to launch is described in the <my_application.xml> file"},
              true);
        
        addOption(new OptionVerbose());
        addOption(new OptionDebug());
        addOption(new OptionProperty());
        addOption(new OptionArg());
        addOption(new OptionContext());
        addOption(new OptionRun());
        addOption(new OptionLoad());
    }
}
