/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_q816Components;

import ist.coach.coachEmfCommon.HeartbeatImpl;
/**
 **  Implementation skeleton class for the ::itut_q816Components::HeartbeatProvider component.
 **/
public class HeartbeatProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_HeartbeatProvider,
                  intt.itu.itut_q816.CCM_Heartbeat,
                  org.omg.Components.SessionComponent,
				  Runnable
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     ** HeartbeatEmitter Thread
     **/
    private Thread publisherThread;
	private String _label;
	private short _period = 100;
	/**
     **  Context reference.
     **/
    private CCM_HeartbeatProvider_Context the_context_;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    HeartbeatProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================

    private void publisher_init() {
		if (publisherThread == null) {
			publisherThread = new Thread(this, "Publisher");
			publisherThread.start();
		}
    }

    private void publisher_stop() {

	  publisherThread = null;
/***
		Thread dummyThread = publisherThread;
		publisherThread = null;
	    dummyThread.interrupt();
*****/
    }
	// ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_HeartbeatProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
		publisher_init();
		System.err.println("HeartbeatProvider configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_HeartbeatProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // DONE: implement !!!
        //
		publisher_stop();
    }
    // ==================================================================
    //
    // Public methods for the CCM_HeartbeatProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_q816Components/CCM_HeartbeatProvider/get_admin:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_HeartbeatProvider::get_admin operation.
     **/
    public intt.itu.itut_q816.CCM_Heartbeat
    get_admin()
    {
        return this;
    }
    //
    //  IDL:coach.ist/itut_q816Components/CCM_HeartbeatProvider_Executor/label:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_HeartbeatProvider_Executor::label attribute as accessor operation.
     **/
    public java.lang.String
    label()
    {
        //
        //  DONE : implement
        //
        return _label;
    }

    /**
     **  Implementation of the ::itut_q816Components::CCM_HeartbeatProvider_Executor::label attribute as mutator operation.
     **/
    public void
    label(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
			_label = new String(val);
		else
			_label = new String();
		System.err.println("Heartbeat Label is set to " + _label);
    }
    // ==================================================================
    //
    // Public methods for the ::itut_q816::CCM_Heartbeat local interface.
    //
    // ==================================================================
    //
    //  IDL:itu.intt/itut_q816/Heartbeat/periodGet:1.0
    //
    /**
     **  Implementation of the ::itut_q816::Heartbeat::periodGet operation.
     **/
    public short
    periodGet()
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
        return _period;
    }
    //
    //  IDL:itu.intt/itut_q816/Heartbeat/periodSet:1.0
    //
    /**
     **  Implementation of the ::itut_q816::Heartbeat::periodSet operation.
     **/
    public void
    periodSet(short period)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		System.err.println("HeartbeatProvider: periodSet> to " + period + " secs");
		_period = period;
    }

	    // ==================================================================
    //
    // Runnable Interface methods.
    //
    // ===================================================================
    public void run() {

		Thread myThread = Thread.currentThread();

		boolean exitCondition = false;
		org.omg.TimeBase.UtcT eventTime;
		System.err.println("Heartbeat Publisher started...");
		while (publisherThread == myThread && !exitCondition) {

				try {
					  Thread.sleep(_period * 1000);
					  eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
							0,(short) 0,(short) 0);
					  //System.err.println("Heartbeat Publisher attempts to emit event!");
					  the_context_.push_heartbeat(new HeartbeatImpl(
												 _label,
												  new String(),
												 _period,
												  eventTime)
												  );


					  if (_period == 0)
						  exitCondition = true;
			}
			catch (InterruptedException ie) {
				System.err.println("Heartbeat Publisher  Exiting");
			}
			catch (Exception e) {
				System.err.println("HeartbeatPublisher>Exception in run(): " + e);
				e.printStackTrace();
			}
		}
   	 }

}
