/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents;
import org.omg.CosNaming.NameComponent;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.CreateController;
import ist.coach.coachEmfCommon.CreateBindingInfo;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;


import ist.coach.coachEmsMib.conditionalPackages.sysInfoSetPackageType;
import ist.coach.coachEmsMib.LogicalInterfaceFactory;
import ist.coach.coachEmsMib.LogicalInterfaceFactoryHelper;
import ist.coach.coachEmsMib.IpProtocolMonitorFactory;
import ist.coach.coachEmsMib.IpProtocolMonitorFactoryHelper;

import ist.coach.coachEmsMib.IpNodeFactory;
import ist.coach.coachEmsMib.IpNodeFactoryHelper;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.ManagedObjectFactoryHelper;
import intt.itu.itut_x780.ManagedObjectFactory;

import intt.itu.itut_m3120.conditionalPackages.*;


import org.opennms.protocols.snmp.SnmpSMI;


/**
 **  Implementation skeleton class for the ::coachEmsMibComponents::IpNodeFactoryProvider component.
 **/
public class IpNodeFactoryProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_IpNodeFactoryProvider,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_IpNodeFactoryProvider_Context the_context_;
   /* Business logic **/
    intt.itu.itut_q816.ContainmentComponent c_admin = null;
    intt.itu.itut_q816.Containment c_query = null;
	//ist.coach.coachEmsMib.LogicalInterfaceFactory logicalInterfaceFactory = null;

	private static final String FACTORY_CLASS = "IpNodeFactory";
	IpNodeMgmt facade = null;

	ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private org.omg.CORBA.ORB orb = null;

	private static final String SYS_CONTACT_OID = ".1.3.6.1.2.1.1.4.0";
	private static final String SYS_NAME_OID = ".1.3.6.1.2.1.1.5.0";
    private static final String SYS_LOCATION_OID = ".1.3.6.1.2.1.1.6.0";
    private static final String [] IP_GROUP_OIDS = {

					IpProtocolMonitorProviderMonolithicImpl.IP_FWD_TYPE_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_DEFAULT_TTL_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_INRECEIVE_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_INHDRERRORS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_INADDRERRORRS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_FWDDATAGRAMS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_INUNKNOWNPROTO_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_INDISCARDS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_INDELIVERS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_OUTREQUESTS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_OUTDISCARDS_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_NOROUTE_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_REASMTIMEOUT_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_REASMREQ_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_REASMOK_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_REASMFAIL_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_FRAGOK_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_FRAGFAIL_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_FRAGCREATE_OID,
					IpProtocolMonitorProviderMonolithicImpl.IP_ROUTING_DISCARDS_OID
	};

	private static final String READ_COMMUNITY = "public";
	private static final String NO_SUCH_OBJECT = "No Such Object";
	private static final String NO_SUCH_INSTANCE = "No Such Instance";

    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    IpNodeFactoryProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================

	private int [] getIfTableIndexes(
		DataType [] ifTable,
		int tableRows,
		int[] indexRows) {

		int numOfEntries = ifTable.length;
		int numOfRows = numOfEntries/tableRows;

		int [] indexes = new int[numOfRows];

		for (int i = 0; i < numOfRows; i++) {

			for (int j = 0; j < indexRows.length; j++) {

				int position = (indexRows[j] - 1)*numOfRows + i;

				if (position >= numOfEntries) {
					System.err.println("IpNodeFactory: getIfTableIndexes> " +
					    "Cannot determine table indexes!");
					return null;
				}

				indexes[i] = ifTable[position].value.extract_long();
			}
		}

		return indexes;
	}

	private String [] getIfTableIfDescrs(
		DataType []  ifTable,
		int tableRows,
		int [] indexRows) {

		int numOfEntries = ifTable.length;
		int numOfRows = numOfEntries/tableRows;

		String [] ifDescrs = new String[numOfRows];

		for (int i = 0; i < numOfRows; i++) {

			for (int j = 0; j < indexRows.length; j++) {

				int position = (indexRows[j] - 1)*numOfRows + i;

				if (position >= numOfEntries) {
					System.err.println("IpNodeFactory: getIfTableIfDescrs> " +
						  "Cannot determine interface descriptions!");
					return null;
				}
				ifDescrs[i] = new String(
				org.omg.CORBA.OctetSeqHelper.extract(ifTable[position].value));
				System.err.println("ifDescrs[" + i + "] = " + ifDescrs[i]);
				//by digi
				//ifDescrs[i] = ifTable[position].value.extract_string();
			}
		}
		return ifDescrs;
	}

    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_IpNodeFactoryProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
	    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
        if ((facade = the_context_.get_connection_facade()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_admin = the_context_.get_connection_containment_admin()) == null)
            throw new org.omg.Components.InvalidConfiguration();

        if ((c_query = the_context_.get_connection_containment_query()) == null)
            throw new org.omg.Components.InvalidConfiguration();

		    // If managers may create, then the factory must register to the
            // factory finder service
        intt.itu.itut_q816.FactoryFinderComponent factoryfinder_admin =
            the_context_.get_connection_factoryfinder_admin();

		if ((connector = the_context_.get_connection_connector()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		 org.omg.CORBA.Object myself_o;
		 IpNodeFactory myself = null;

        try {
			myself_o = ((org.omg.Components.SessionContext) the_context_).get_CCM_object();
        	myself = IpNodeFactoryHelper.narrow(myself_o);

            factoryfinder_admin.register(FACTORY_CLASS, myself);
        }
        catch(intt.itu.itut_x780.ApplicationError ex) {
            throw new org.omg.Components.InvalidConfiguration();
        }
		catch(Exception e) {
			System.err.println("IpNodeFactory has problems retrieving CCM component");
		}

        this.orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("IpNodeFactoryProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_IpNodeFactoryProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_IpNodeFactoryProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMib/IpNodeFactory/create_ipNode:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::IpNodeFactory::create operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    create( java.lang.String nameBinding,
			org.omg.CosNaming.NameComponent[] superior,
			java.lang.String reqID,
			java.lang.String[] packageNameList,
			java.lang.String domainName,
			java.lang.String hostname,
			byte[]  managementIPAddress,
			int supportedSnmpVersions,
			intt.itu.itut_x780.AdministrativeStateType administrativeState,
			java.lang.String userLabel,
			java.lang.String vendorName,
			java.lang.String version,
			java.lang.String locationName,
			int snmpPort,
			java.lang.String sysName,
			java.lang.String sysContact)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //

        String nameBinding_str = "ist.coach.coachEmsMib.NameBindings." +
                nameBinding;

//		String objectKind = CreateController.checkNameBinding(nameBinding_str);

		CreateBindingInfo info = CreateController.checkNameBinding(nameBinding_str);

		String objectKind = info.objectKind;
		short deletePolicy = info.deletePolicy;

        // Check if the parent exists
        if (! c_query.exists(superior)) {
            ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);

            error_code.details = Utils.name2string(superior) +
                            ExceptionMessages.parent_object_error;

            throw new ApplicationError(error_code);
        }

        // The system must have the capability of auto-naming objects
        String allocatedId = reqID;
        if (reqID == null || reqID.length() == 0) {

            org.omg.CosNaming.NameComponent[][] siblings =
                c_query.getContained(superior);

				allocatedId = CreateController.autoCreateId(siblings);
        }

        // Construct the name of the new object
        org.omg.CosNaming.NameComponent[] name = CreateController.createFullName(
					superior,
					allocatedId,
					Utils.name2facade(facade.facade_name()),
					objectKind);

        // Decide the conditional packages that are supported.
        String [] supportedConditionalPackages = packageNameList;

        if (packageNameList.length == 0) {

            System.err.println("No packages are specified." +
                "Trying to determine supported packages...");

            if (vendorName.equalsIgnoreCase("Linux") ||
                vendorName.equalsIgnoreCase("RedHat Linux")  ||
                vendorName.equalsIgnoreCase("RedHat")) {

                System.err.println("IpNodeFactoryProvider>Found linux System...");

                System.err.println("supported packages:");
                System.err.println("\t" + sysInfoSetPackageType.value);
                System.err.println("\t" + locationNamePackageType.value);
                System.err.println("\t" + userLabelPackageType.value);
                System.err.println("\t" + vendorNamePackageType.value);
                System.err.println("\t" + versionPackageType.value);

                supportedConditionalPackages = new String[5];

                supportedConditionalPackages[0] = sysInfoSetPackageType.value;
                supportedConditionalPackages[1] = locationNamePackageType.value;
                supportedConditionalPackages[2] = userLabelPackageType.value;
                supportedConditionalPackages[3] = vendorNamePackageType.value;
                supportedConditionalPackages[4] = versionPackageType.value;
            }
        }
        else {
            System.err.println("Factory will not determine supported conditional Packages," +
                " because Manager already specified them.");
        }


        if (Utils.packageIsSupported(sysInfoSetPackageType.value, supportedConditionalPackages)) {

			System.err.println("sysName: " + sysName);

            org.omg.CORBA.Any sysNameValue = orb.create_any();
			org.omg.CORBA.OctetSeqHelper.insert(sysNameValue, sysName.getBytes());

			DataTypeImpl sysNameDataType = new DataTypeImpl(SYS_NAME_OID,
			  sysNameValue, SnmpSMI.SMI_STRING);


               //by digi
			//sysNameValue.insert_string(sysName);
            //DataTypeImpl sysNameDataType = new DataTypeImpl(SYS_NAME_OID,
	  	   // sysNameValue, SnmpSMI.SMI_STRING);

			System.err.println("sysContact: " + sysContact);
            org.omg.CORBA.Any sysContactValue = orb.create_any();
            org.omg.CORBA.OctetSeqHelper.insert(sysContactValue, sysName.getBytes());

            DataTypeImpl sysContactDataType = new DataTypeImpl(SYS_CONTACT_OID,
                sysNameValue, SnmpSMI.SMI_STRING);
				//by digi
			    //sysContactValue.insert_string(sysContact);
				//DataTypeImpl sysContactDataType = new DataTypeImpl(SYS_CONTACT_OID,
				//sysContactValue, SnmpSMI.SMI_STRING);

            DataTypeImpl [] sysData = {sysNameDataType, sysContactDataType};

            try {
                connector.setBulk(
                    sysData,
                    new String(managementIPAddress),
                    snmpPort,
                    "private");
            }
            catch (SnmpApplicationError e) {

				CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
             	error_code.error = new UIDType(
               	  	intt.itu.itut_x780.CreateErrorConst.moduleName.value,
               	  	intt.itu.itut_x780.CreateErrorConst.unsupportedPackages.value);

             		error_code.details = e.reason;

        	     throw new CreateError(error_code);
            }
			catch(Exception e) {
			  System.err.println("IpNodeFactory> Exception caught:" + e.getMessage());
			  e.printStackTrace(System.err);
			}
        }

        if (Utils.packageIsSupported(locationNamePackageType.value, supportedConditionalPackages)) {

            org.omg.CORBA.Any sysLocationValue = orb.create_any();

			org.omg.CORBA.OctetSeqHelper.insert(sysLocationValue, locationName.getBytes());

           // by digi
		   //sysLocationValue.insert_string(locationName);
            DataTypeImpl sysLocationDataType = new DataTypeImpl(SYS_LOCATION_OID,
                sysLocationValue, SnmpSMI.SMI_STRING);

            try {
                connector.set(
                    sysLocationDataType,
                    new String(managementIPAddress),
                    snmpPort,
                    "private");
            }
            catch (SnmpApplicationError e) {

             CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
             error_code.error = new UIDType(
                 intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                 intt.itu.itut_x780.CreateErrorConst.unsupportedPackages.value);

             error_code.details = e.reason;
             throw new CreateError(error_code);
            }
			catch (Exception e) {
			  System.err.println("System exception caught:" + e.getMessage());
			  e.printStackTrace(System.err);
			}

        }

        System.err.println("IpNodeFactory> Before invoking the facade " +
                    Utils.name2facade(facade.facade_name()) + " to create " + Utils.name2string(name));

        //facade.create(name, objectKind, new String[0], deletePolicy,
        facade.create(name, objectKind, supportedConditionalPackages, deletePolicy,
                    intt.itu.itut_x780.SourceIndicatorType.managementOperation,
					domainName,
					hostname,
					managementIPAddress,
					supportedSnmpVersions,
					administrativeState,
					userLabel,
					vendorName,
					version,
					locationName,
					(short)snmpPort,
					sysName,
					sysContact);

		 System.err.println("IpNodeFactory>Before registering to the containment service");
        	c_admin.addName(name, superior);
		System.err.println("IpNodeFactory>After registering to the containment service");

		// HACK: digi: Maybe a utility class would be better...
		// Code below is not good. Written just for testing.

		DataType[] ifTable = new DataType[0];
		try {
			ifTable = this.connector.getSnmpTable(
				LogicalInterfaceProviderMonolithicImpl.IF_TABLE_OID,
            		new String(managementIPAddress),
            		snmpPort,
				"public");
		}
		catch(ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {
			System.err.println("SnmpApplicationError caught> " +
						snmp_ex.reason);
				return name;
		}
		catch(Exception e) {
		  System.err.println("IpNodeFactory: create>Exception caught: " + e.getMessage());
		  e.printStackTrace(System.err);
		}

		int[] indexRows = { 1 };
		int [] ifTableIndexes = getIfTableIndexes(ifTable,
			18, indexRows);

		int[] ifDescrIndexRows = { 2 };
		String [] ifTableIfDescrs = getIfTableIfDescrs(ifTable,
			18, ifDescrIndexRows);

		if (ifTableIndexes == null) {
			System.err.println("Indexes could not be determined for" +
				" Logical Interfaces. No Logical Interface objects will" +
				" be created.");
		}
		else
		if (ifTableIndexes.length == 0)
			System.err.println("No LogicalInterface objects found");
		else
		if (ifTableIfDescrs.length == 0)
			System.err.println("Could not determine interface descriptions " +
				"for Logical Interface Objects");
		else
		if (ifTableIfDescrs.length != ifTableIndexes.length)
			System.err.println("Mapping of ifDescr is not one-to-one with " +
				"Logical Interface objects");
		else {

			LogicalInterfaceFactory lif =
			  the_context_.get_connection_logicalInterfaceFactory();

			if (lif == null)
				System.err.println("Factory is null..." +
					" No LogicalInterface Objects will be created.");
			else {

				System.err.println("IpNodeFactoryProvider>******FOUND " +
				    ifTableIndexes.length +
					" LogicalInterface Objects");

				String [] logicalInterfacePackages = new String[0];

            	if (vendorName.equalsIgnoreCase("Linux") ||
               		vendorName.equalsIgnoreCase("RedHat Linux")  ||
               		vendorName.equalsIgnoreCase("RedHat")) {

               		System.err.println("IpNodeFactoryProvider:create> Found linux System..." +
						"No package is supported for LogicalInterface");
				}

				for (int i = 0; i < ifTableIndexes.length; i++) {
					lif.create(
						"LogicalInterface_IpNode",
						name,
						ifTableIfDescrs[i],
						logicalInterfacePackages,
						ifTableIndexes[i],
						managementIPAddress,
						snmpPort,
						supportedSnmpVersions,
						ifTableIfDescrs[i]);
				}
			}
		}

		// IpProtocolMonitor creation
		try {

			DataType[] res = this.connector.getBulk(
					IP_GROUP_OIDS,
            		new String(managementIPAddress),
            		snmpPort,
					READ_COMMUNITY);

			int count = 0;

			for (int i = 0; i < res.length; i++) {
				try {
					if ( (res[i].value.extract_string().equalsIgnoreCase(
						NO_SUCH_OBJECT)) ||
						(res[i].value.extract_string().equalsIgnoreCase(
						NO_SUCH_INSTANCE)) )
					count ++;
				}
				catch (org.omg.CORBA.BAD_OPERATION badOp) {
					// If a string cannot be extracted, then the result
					// will not be "No Such Object", or "No Such Instance"
					// so no problem then! Catch this exception and ignore it.
				}
			}

			if (count < res.length) {
				//System.err.println("IpProtocolMonitor must be created.");

				IpProtocolMonitorFactory ipf =
				   the_context_.get_connection_ipProtocolMonitorFactory();

				if (ipf == null) {
					System.err.println("IpProtocolMonitorFactory is null..." +
						" No IpProtocolMonitor Object will be created!");
				}
				else {
					System.err.println("Invoking IpProtocolMonitorFactory...");

					String [] ipProtocolMonitorPackages = new String[0];

            		if (vendorName.equalsIgnoreCase("Linux") ||
                		vendorName.equalsIgnoreCase("RedHat Linux")  ||
                		vendorName.equalsIgnoreCase("RedHat")) {

                		//System.err.println("Found linux System..." +
						//	"No package is supported for IpProtocolMonitor");
					}

					ipf.create(
						"IpProtocolMonitor_IpNode",
						name,
						"IpProtocol",
						ipProtocolMonitorPackages,
						managementIPAddress,
						snmpPort,
						supportedSnmpVersions
					);

				}
			} // IpProtocolMonitor must be created
		}
		catch (SnmpApplicationError e) {
			System.err.println("\nIpNodeFactory:SnmpApplicationError while trying to create IpProtocolMonitorFactory");
			System.err.println("Reason:" + e.reason);
			// Continue to create other objects, if possible...
		}
        System.err.println("IpNodeFactory>create returns for " + Utils.name2string(name));


        return name;

    }


/*** TEMP ******/
    // ==================================================================
    //
    // Public methods for the CCM_ManagedObjectFactoryProvider local interface.
    //
    // ==================================================================
    public org.omg.CosNaming.NameComponent[]
    create_base(String nameBinding,
                org.omg.CosNaming.NameComponent[] superior,
                String reqId)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError {

		return new NameComponent[0];
	}
}
