/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.coachEmsMibComponents;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.CreateController;
import ist.coach.coachEmfCommon.CreateBindingInfo;
import ist.coach.coachEmfCommon.ExceptionMessages;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;

import intt.itu.itut_m3120.conditionalPackages.*;

import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import org.omg.CosNaming.NameComponent;
/**
 **  Implementation skeleton class for the ::coachEmsMibComponents::LogicalInterfaceFactoryProvider component.
 **  Business operations MUST be completed !!!
 **/
public class LogicalInterfaceFactoryProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_LogicalInterfaceFactoryProvider,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_LogicalInterfaceFactoryProvider_Context the_context_;
	/* Business logic **/
	intt.itu.itut_q816.ContainmentComponent c_admin = null;
	intt.itu.itut_q816.Containment c_query = null;

	private static final String FACTORY_CLASS = "LogicalInterfaceFactory";
	LogicalInterfaceMgmt facade = null;

	ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;




    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    LogicalInterfaceFactoryProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_LogicalInterfaceFactoryProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((facade = the_context_.get_connection_facade()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((c_admin = the_context_.get_connection_containment_admin()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((c_query = the_context_.get_connection_containment_query()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((connector = the_context_.get_connection_connector()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		System.err.println("LogicalIntefaceFactoryProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_LogicalInterfaceFactoryProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_LogicalInterfaceFactoryProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/coachEmsMib/LogicalInterfaceFactory/create:1.0
    //
    /**
     **  Implementation of the ::coachEmsMib::LogicalInterfaceFactory::create operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    create(java.lang.String nameBindingID,
			org.omg.CosNaming.NameComponent[] superior,
			String reqID,
			java.lang.String[] packageNameList,
			int ifIndex,
			byte [] mgmtIpAddress,
			int snmpPort,
			int supportedSnmpVersions,
			java.lang.String ifDescr)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //

		String nameBinding_str = "ist.coach.coachEmsMib.NameBindings." +
			nameBindingID;

		CreateBindingInfo info = CreateController.checkNameBinding(nameBinding_str);

		String objectKind = info.objectKind;
		short deletePolicy = info.deletePolicy;

		// Check if the parent exists
		if (! c_query.exists(superior)) {
			ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);


			error_code.details = Utils.name2string(superior) +
				ExceptionMessages.parent_object_error;

			throw new ApplicationError(error_code);
		}

		// The system must have the capability to auto-name objects

		String allocatedId = null;
		if (reqID == null || reqID.length() == 0) {
			org.omg.CosNaming.NameComponent[][] siblings =
			c_query.getContained(superior);

			allocatedId = CreateController.autoCreateId(siblings);
		}
		else
			allocatedId = reqID;

		// Construct the name of the new object

		org.omg.CosNaming.NameComponent[] name = CreateController.createFullName(
				superior,
				allocatedId,
				Utils.name2facade(facade.facade_name()),
				objectKind);

		// Decide the conditional packages that are supported.
		String [] supportedConditionalPackages = packageNameList;

		if (packageNameList.length == 0)
			System.err.println("No packages are specified. ");

		System.err.println("LogicalInterfaceFactory> Before invoking the facade " +
			Utils.name2facade(facade.facade_name()) + " to create " +
			Utils.name2string(name));

			facade.create(
				name,
				objectKind,
				packageNameList,
				deletePolicy,
				intt.itu.itut_x780.SourceIndicatorType.resourceOperation,
				superior,
				ifIndex,
				mgmtIpAddress,
				snmpPort,
				supportedSnmpVersions,
				ifDescr);

			System.err.println("Before registering to the containment service");
			c_admin.addName(name, superior);

			System.err.println("LogicalInterfaceFactory>create returns for " +
				Utils.name2string(name));

			return name;
    }

    //
    //  IDL:itu.intt/itut_x780/ManagedObjectFactory/create_base:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObjectFactory::create_base operation.
     **/
    public org.omg.CosNaming.NameComponent[]
    create_base(java.lang.String nameBinding,
			org.omg.CosNaming.NameComponent[] superior,
			java.lang.String reqId)
    throws intt.itu.itut_x780.CreateError, intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
        return new NameComponent[0];
    }
}
